open Datatypes
open Peano
open Vector
open Minski
open Compilation

let rec (!)  n = match n with 0 -> O | n -> S (!(n-1))
let rec (!?) n = match n with O -> 0 | S n -> 1 + !?n
let (!&) l = 
  let rec aux n = function
    | [] -> Coq_nnil
    | x::q -> Coq_ncons(!(n-1), !x, aux (n-1) q)
  in
    aux (List.length l) l

let f = compile !1 Recursive.coq_Add
(*let f = compile !1 Recursive.coq_Sqrt*)
let _ = Printf.printf "compiled (%i,%i)\n%!" !?(ms f) !?(ns f)
let res = execute_N f !20000 !2 !&[4; 38]
(* let res = execute_N f !5 !1 !&[0] *)
let () = match res with 
  | None -> print_string "None...\n"
  | Some n -> print_int !?n; print_string "\n"

